package{
  import flash.geom.Vector3D;
  import figure.Point3D;

//--------------------------------------------------------------------//
// iq_|C^
  public class Pointer{

// xCfbNX
    public var x:int;

// yCfbNX
    public var y:int;

// zCfbNX
    public var z:int;

//--------------------------------------------------------------------//
// iq_|C^\z
// x - xCfbNX
// y - yCfbNX
// z - zCfbNX
    public function Pointer(x:int=-1,y:int=-1,z:int=-1){
      set(x,y,z);
    }

//--------------------------------------------------------------------//
// |C^ݒ肷
// x - xCfbNX
// y - yCfbNX
// z - zCfbNX
    public function set(x:int,y:int,z:int):void{
      this.x=x;
      this.y=y;
      this.z=z;
    }

//--------------------------------------------------------------------//
// fʊiq_̃XgԂ
// nx - xiq_
// ny - yiq_
// nz - ziq_
// grid - iq_̃Xg
    public function getSection(nx:int,ny:int,nz:int,grid:Array):Array{
      if(x>=0){
      	var pg:Array=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  pg[j]=new Vector.<Point3D>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    pg[j][k]=grid[x][j][k];
      	  }
      	}
      	return pg;
      }
      if(y>=0){
      	pg=new Array(nx);
      	for(var i:int=0;i<nx;i++){
      	  pg[i]=new Vector.<Point3D>(nz,true);
      	  for(k=0;k<nz;k++){
      	    pg[i][k]=grid[i][y][k];
      	  }
      	}
      	return pg;
      }
      if(z>=0){
      	pg=new Array(nx);
      	for(i=0;i<nx;i++){
      	  pg[i]=new Vector.<Point3D>(ny,true);
      	  for(j=0;j<ny;j++){
      	    pg[i][j]=grid[i][j][z];
      	  }
      	}
      	return pg;
      }
      else{
      	return [[]];
      }
    }

//--------------------------------------------------------------------//
// fʊiq_̑x̃XgԂ
// nx - xiq_
// ny - yiq_
// nz - ziq_
// u - xx̃Xg
// v - xỹXg
// w - xz̃Xg
    public function getSectionV(nx:int,ny:int,nz:int,
      	      	      	      	u:Array,v:Array,w:Array):Array{
      if(x>=0){
      	var vg:Array=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  vg[j]=new Vector.<Vector3D>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    vg[j][k]=new Vector3D
      	      (0.5*(u[x+1][j][k]+u[x+1][j+1][k]
      	      	   +u[x+1][j][k+1]+u[x+1][j+1][k+1]),
      	       0.5*(v[x][j+1][k]+v[x+1][j+1][k]
      	      	   +v[x][j+1][k+1]+v[x+1][j+1][k+1]),
      	       0.5*(w[x][j][k+1]+w[x+1][j][k+1]
      	      	   +w[x][j+1][k+1]+w[x+1][j+1][k+1]),1.0);
      	  }
      	}
      	return vg;
      }
      else if(y>=0){
      	vg=new Array(nx);
      	for(var i:int=0;i<nx;i++){
      	  vg[i]=new Vector.<Vector3D>(nz,true);
      	  for(k=0;k<nz;k++){
      	    vg[i][k]=new Vector3D
      	      (0.5*(u[i+1][y][k]+u[i+1][y+1][k]
      	      	   +u[i+1][y][k+1]+u[i+1][y+1][k+1]),
      	       0.5*(v[i][y+1][k]+v[i+1][y+1][k]
      	      	   +v[i][y+1][k+1]+v[i+1][y+1][k+1]),
      	       0.5*(w[i][y][k+1]+w[i+1][y][k+1]
      	      	   +w[i][y+1][k+1]+w[i+1][y+1][k+1]),1.0);
      	  }
      	}
      	return vg;
      }
      else if(z>=0){
      	vg=new Array(nx);
      	for(i=0;i<nx;i++){
      	  vg[i]=new Vector.<Vector3D>(ny,true);
      	  for(j=0;j<ny;j++){
      	    vg[i][j]=new Vector3D
      	      (0.5*(u[i+1][j][z]+u[i+1][j+1][z]
      	      	   +u[i+1][j][z+1]+u[i+1][j+1][z+1]),
      	       0.5*(v[i][j+1][z]+v[i+1][j+1][z]
      	      	   +v[i][j+1][z+1]+v[i+1][j+1][z+1]),
      	       0.5*(w[i][j][z+1]+w[i+1][j][z+1]
      	      	   +w[i][j+1][z+1]+w[i+1][j+1][z+1]),1.0);
      	  }
      	}
      	return vg;
      }
      else{
      	return [[]];
      }
    }

//--------------------------------------------------------------------//
// fʊiq_̃p[^̃XgԂ
// nx - xiq_
// ny - yiq_
// nz - ziq_
// p iqS_̃p[^̃Xg
  public function atSectionPoint(nx:int,ny:int,nz:int,p:Array):Array{
    if(x>=0){
      	var pp:Array=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  pp[j]=new Vector.<Number>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    pp[j][k]=0.125*(p[x][j][k]+p[x][j+1][k]+p[x+1][j][k]
      	      	      	   +p[x+1][j+1][k]+p[x][j][k+1]+p[x][j+1][k+1]
      	      	      	   +p[x+1][j][k+1]+p[x+1][j+1][k+1]);
      	  }
      	}
      	return pp;
      }
      else if(y>=0){
      	pp=new Array(nx);
      	for(var i:int=0;i<nx;i++){
      	  pp[i]=new Vector.<Number>(nz,true);
      	  for(k=0;k<nz;k++){
      	    pp[i][k]=0.125*(p[i][y][k]+p[i][y+1][k]+p[i+1][y][k]
      	      	      	   +p[i+1][y+1][k]+p[i][y][k+1]+p[i][y+1][k+1]
      	      	      	   +p[i+1][y][k+1]+p[i+1][y+1][k+1]);
      	  }
      	}
      	return pp;
      }
      else if(z>=0){
      	pp=new Array(nx);
      	for(i=0;i<nx;i++){
      	  pp[i]=new Vector.<Number>(ny,true);
      	  for(j=0;j<ny;j++){
      	    pp[i][j]=0.125*(p[i][j][z]+p[i][j+1][z]+p[i+1][j][z]
      	      	      	   +p[i+1][j+1][z]+p[i][j][z+1]+p[i][j+1][z+1]
      	      	      	   +p[i+1][j][z+1]+p[i+1][j+1][z+1]);
      	  }
      	}
      	return pp;
      }
      else{
      	return [[]];
      }
    }
  }
}
