package{

//--------------------------------------------------------------------//
// SOR@̌vZ
  public class SORCondition{

// 񐔂̍ől
    public var iterMax:int;

// ɘaW
    public var relax:Number;

// 臒l
    public var theshold:Number;

//--------------------------------------------------------------------//
// SOR@̌vZ\z
// iterMax - 񐔂̍ől
// relaxn- ɘaW
// theshold - 臒l
    public function SORCondition(iterMax:int,relax:Number,
      	      	      	      	 theshold:Number){
      this.iterMax=iterMax;
      this.relax=relax;
      this.theshold=theshold;
    }

//--------------------------------------------------------------------//
// SOR@ŌvZcԂ
// ixs - xCfbNX̊Jnl
// iys - yCfbNX̊Jnl
// izs - zCfbNX̊Jnl
// nx - xCfbNX͈̔
// ny - yCfbNX͈̔
// nz - zCfbNX͈̔
// p - p[^̃Xg
// coef - šW̃Xg
    public function sor(ixs:int,iys:int,izs:int,nx:int,ny:int,nz:int,
      	      	      	p:Array,coef:Array):Number{
      var err:Number=0.0;
      for(var itr:int=0;itr<iterMax;itr++){
      	err=0.0;
      	var psum:Number=0.0;
      	for(var i:int=ixs;i<nx;i++){
      	  for(var j:int=iys;j<ny;j++){
      	    for(var k:int=izs;k<nz;k++){
      	      var dp:Number=coef[i][j][k].next(i,j,k,p)-p[i][j][k];
      	      p[i][j][k]+=relax*dp;
      	      err+=Math.abs(dp);
      	      psum+=Math.abs(p[i][j][k]);
      	    }
      	  }
      	}
      	if(psum>0.0) err/=psum;
      	if(err<theshold) return err;
      }
      return err;
    }
  }
}
