package figure{

//--------------------------------------------------------------------//
// 
  public class Cube3D{

// xW
    public var x:Number;

// yW
    public var y:Number;

// zW
    public var z:Number;

// x
    public var width:Number;

// y
    public var height:Number;

// zs
    public var depth:Number;

//--------------------------------------------------------------------//
// ̂\z
// x,y,z - x,y,zW
// width,height,depth - x,y,zs
    public function Cube3D(x:Number=0.0,y:Number=0.0,z:Number=0.0,
      	      	      	   width:Number=0.0,height:Number=0.0,
      	      	      	   depth:Number=0.0){
      this.x=x;
      this.y=y;
      this.z=z;
      this.width=width;
      this.height=height;
      this.depth=depth;
    }

//--------------------------------------------------------------------//
// Wݒ肷
// x,y,z - x,y,zW
    public function setLocation(x:Number,y:Number,z:Number):void{
      this.x=x;
      this.y=y;
      this.z=z;
    }

//--------------------------------------------------------------------//
// 傫ݒ肷
// width,height,depth - x,y,zs
    public function setSize(width:Number,height:Number,
      	      	      	    depth:Number):void{
      this.width=width;
      this.height=height;
      this.depth=depth;
    }

//--------------------------------------------------------------------//
// Eݒ肷
// x,y,z - x,y,zW
// width,height,depth - x,y,zs
    public function setBounds(x:Number=0.0,y:Number=0.0,z:Number=0.0,
      	      	      	      width:Number=0.0,height:Number=0.0,
      	      	      	      depth:Number=0.0):void{
      this.x=x;
      this.y=y;
      this.z=z;
      this.width=width;
      this.height=height;
      this.depth=depth;
    }

//--------------------------------------------------------------------//
// ̓_̃Rs[쐬
    public function copy():Cube3D{
      return new Cube3D(x,y,z,width,height,depth);
    }

//--------------------------------------------------------------------//
// SʒuԂ
    public function getCenterLocation():Point3D{
      return new Point3D(x+0.5*width,y+0.5*height,z+0.5*depth);
    }

//--------------------------------------------------------------------//
// ̂g債Č̒̂Ɠ_܂ލŏ̒̂𐶐
// x,y,z- _x,y,zW
    public function inflate(x:Number,y:Number,z:Number):void{
      var xmin:Number=Math.min(this.x,x);
      var ymin:Number=Math.min(this.y,y);
      var zmin:Number=Math.min(this.z,z);
      var xmax:Number=Math.max(this.x+width,x);
      var ymax:Number=Math.max(this.y+height,y);
      var zmax:Number=Math.max(this.z+depth,z);
      this.x=xmin;
      this.y=ymin;
      this.z=zmin;
      width=xmax-xmin;
      height=ymax-ymin;
      depth=zmax-zmin;
    }
  }
}
