package figure{

//--------------------------------------------------------------------//
// Ả߂邽߂̕WsNX
  public class DefaultMatrixSolver extends DefaultMatrix{

//--------------------------------------------------------------------//
// size - sE̐
    public function DefaultMatrixSolver(size:int){
      super(size,size);
    }

//--------------------------------------------------------------------//
// I LU @ŘẢ߂
// ̍s͕ێȂ
// p - xNg
// tolerance - 臒l
    public function solveByLUNoPreserv(p:Vector.<Number>,
      	      	      	      	       tolerance:Number):Vector.<Number>{
      init();
      tolerance*=dataMax;
      var index:Vector.<int>=new Vector.<int>(rowCount,true);
      for(var i:int=0;i<rowCount;i++) index[i]=i;

      var q:Vector.<Number>=new Vector.<Number>(rowCount,true);
      for(i=0;i<rowCount-1;i++){
      	var p2:Number=p[i];
      	for(var j:int=0;j<i;j++){
      	  p2-=data[i][j]*q[j];
      	}

      	var dmax:Number=Math.abs(data[i][i]);
      	var kmax:int=i;
      	for(var k:int=i+1;k<columnCount;k++){
      	  if(Math.abs(data[i][k])>dmax){
      	    dmax=Math.abs(data[i][k]);
      	    kmax=k;
      	  }
      	}
      	if(dmax<tolerance){
      	  throw new Error
      	    ("matrix solve error at row "+(i+1)+"/"+rowCount+" "+dmax);
      	}
      	if(i!=kmax){
      	  for(j=0;j<rowCount;j++){
      	    dmax=data[j][i];
      	    data[j][i]=data[j][kmax];
      	    data[j][kmax]=dmax;
      	  }
      	  var itemp:int=index[i];
      	  index[i]=index[kmax];
      	  index[kmax]=itemp;
      	}

      	var minv:Number=1.0/data[i][i];
      	for(j=i+1;j<columnCount;j++){
      	  data[i][j]*=minv;
      	}
      	for(j=i+1;j<rowCount;j++){
      	  var mji:Number=-data[j][i];
      	  if(mji!=0.0){
      	    for(k=i+1;k<columnCount;k++){
      	      data[j][k]+=mji*data[i][k];
      	    }
      	  }
      	}
      	q[i]=p2*minv;
      }
      if(Math.abs(data[rowCount-1][columnCount-1])<tolerance){
      	throw new Error
      	  ("matrix solve error at row "+rowCount+"/"+rowCount);
      }
      p2=p[rowCount-1];
      for(j=0;j<rowCount-1;j++){
      	p2-=data[columnCount-1][j]*q[j];
      }
      q[rowCount-1]=p2/data[rowCount-1][columnCount-1];

      for(i=rowCount-2;i>=0;i--){
      	for(j=i+1;j<columnCount;j++){
      	  q[i]-=data[i][j]*q[j];
      	}
      }

      var x:Vector.<Number>=new Vector.<Number>(rowCount,true);
      for(i=0;i<rowCount;i++) x[index[i]]=q[i];
      return x;
    }
  }
}
