package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.events.TimerEvent;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import flash.ui.Keyboard;
  import flash.utils.Timer;
  import component.Button;
  import component.ComboBox;
  import component.TextBox;

//--------------------------------------------------------------------//
// ANVǗNX
  public class FVMActionManager{

// Xe[W
    internal var stage:Stage;

// \iqL̐ϖ@\f
    internal var view:FVMViewModel;

// }EX{^Ă邩ǂ
    internal var pressed:Boolean;

// }EXʒu
    internal var mx:int;
    internal var my:int;

// ^C}[
    internal var timer:Timer;

// \ʐؑփR{{bNX
    internal var result:ComboBox;

// fʐؑփR{{bNX
    internal var section:ComboBox;

//--------------------------------------------------------------------//
// sprite - eXvCg
// view - \iqL̐ϖ@\f
// waitTime - ^C}[Ԋuimsecj
// x,y,width - \ʒuAA
// textFormat - eLXg
    public function FVMActionManager(sprite:Sprite,view:FVMViewModel,
      	      	      	      	     waitTime:int,
      	      	      	      	     x:int,y:int,width:int,
      	      	      	      	     textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      stage.addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
      stage.addEventListener(MouseEvent.MOUSE_UP,mouseReleased);
      stage.addEventListener(MouseEvent.MOUSE_MOVE,mouseMoved);
      stage.addEventListener(KeyboardEvent.KEY_DOWN,keyPressed);
      pressed=false;
      mx=0;
      my=0;
      addButtons(sprite,x,y,width,textFormat);
      timer=new Timer(waitTime);
      timer.addEventListener(TimerEvent.TIMER,run);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;

      var res:Vector.<String>=
      	Vector.<String>(["None","Pressure","Temperature"]);
      var sect:Vector.<String>=
      	Vector.<String>(["X-Y","Y-Z","Z-X"]);

      var start:Button=new Button("Start",fgColor,bgColor,
      	      	      	      	  0,y,textFormat);
      var stop:Button=new Button("Stop",fgColor,bgColor,
      	      	      	      	 0,y,textFormat);
      var restart:Button=new Button("Restart",fgColor,bgColor,
      	      	      	      	    0,y,textFormat);
      var rLabel:TextField=createLabelField("Contour",0,y,
      	      	      	      	      	    textFormat);
      result=new ComboBox(res,fgColor,bgColor,0,y,
      	      	      	  textFormat,ComboBox.ABOVE,2);
      var sLabel:TextField=createLabelField("Section",0,y,
      	      	      	      	      	    textFormat);
      section=new ComboBox(sect,fgColor,bgColor,0,y,
      	      	      	   textFormat,ComboBox.ABOVE,0);
      var minus:Button=new Button("<",fgColor,bgColor,
      	      	      	      	  0,y,textFormat);
      var plus:Button=new Button(">",fgColor,bgColor,
      	      	      	      	 0,y,textFormat);
      var w:int=start.width+stop.width+restart.width+rLabel.width
      	       +result.width+sLabel.width+section.width
      	       +minus.width+plus.width+7*TextBox.CL;
      start.x=x+(width-w)/2;
      stop.x=start.x+start.width+TextBox.CL;
      restart.x=stop.x+stop.width+TextBox.CL;
      rLabel.x=restart.x+restart.width+TextBox.CL;
      result.x=rLabel.x+rLabel.width+TextBox.CL;
      sLabel.x=result.x+result.width+TextBox.CL;
      section.x=sLabel.x+sLabel.width+TextBox.CL;
      minus.x=section.x+section.width+TextBox.CL;
      plus.x=minus.x+minus.width;

      start.addEventListener(MouseEvent.CLICK,calcStart);
      stop.addEventListener(MouseEvent.CLICK,calcStop);
      restart.addEventListener(MouseEvent.CLICK,calcRestart);
      result.addEventListener(ComboBox.SELECT,selectResult);
      section.addEventListener(ComboBox.SELECT,selectSection);
      minus.addEventListener(MouseEvent.CLICK,sectionDown);
      plus.addEventListener(MouseEvent.CLICK,sectionUp);

      sprite.addChild(start);
      sprite.addChild(stop);
      sprite.addChild(restart);
      sprite.addChild(rLabel);
      sprite.addChild(result);
      sprite.addChild(sLabel);
      sprite.addChild(section);
      sprite.addChild(minus);
      sprite.addChild(plus);
    }

//--------------------------------------------------------------------//
// xpeLXgtB[h쐬
// s - eLXg
// x,y - \ʒu
// textFormat - eLXg
    internal function createLabelField(s:String,x:Number,y:Number,
      	      	      	      	       textFormat:TextFormat):TextField{
      var field:TextField=new TextField();
      field.defaultTextFormat=textFormat;
      field.selectable=false;
      field.background=true;
      field.text=s;
      field.x=x;
      field.y=y;
      field.width=field.textWidth+TextBox.CL;
      field.height=field.textHeight+TextBox.CL;
      return field;
    }

//--------------------------------------------------------------------//
// }EX{^̏s
    internal function mousePressed(event:MouseEvent):void{
      pressed=true;
      mx=stage.mouseX;
      my=stage.mouseY;
    }

//--------------------------------------------------------------------//
// }EX{^𗣂̏s
    internal function mouseReleased(event:MouseEvent):void{
      pressed=false;
    }

//--------------------------------------------------------------------//
// }EX{^ړ̏s
    internal function mouseMoved(event:MouseEvent):void{
      if(pressed){
      	if(event.shiftKey){
      	  view.translate(stage.mouseX-mx,stage.mouseY-my);
      	}
      	else if(event.ctrlKey){
      	  view.zoom(stage.mouseX-mx,stage.mouseY-my);
      	}
      	else{
      	  view.rotate(stage.mouseX-mx,stage.mouseY-my);
      	}
      	mx=stage.mouseX;
      	my=stage.mouseY;
      	view.draw();
      }
    }

//--------------------------------------------------------------------//
//L[̏s
    internal function keyPressed(event:KeyboardEvent):void{
      switch(event.keyCode){
      	case Keyboard.NUMPAD_0:
      	case Keyboard.NUMBER_0:
      	case Keyboard.A:
      	case Keyboard.Z:
      	  view.initView();
      	  break;
      	case Keyboard.X:
      	  view.viewX();
      	  break;
      	case Keyboard.Y:
      	  view.viewY();
      	  break;
      }
    }

//--------------------------------------------------------------------//
// vZJn
    internal function calcStart(event:Event):void{
      timer.reset();
      Generator.setBenardField(view.getModel());
      view.getModel().init();
      timer.start();
    }

//--------------------------------------------------------------------//
// vZ𒆒f
    internal function calcStop(event:Event):void{
      timer.stop();
    }

//--------------------------------------------------------------------//
// vZĊJ
    internal function calcRestart(event:Event):void{
      timer.start();
    }

//--------------------------------------------------------------------//
// \ʂ؂ւ
    internal function selectResult(event:Event):void{
      view.setResult(result.index);
      view.draw();
    }

//--------------------------------------------------------------------//
// fʂ؂ւ
    internal function selectSection(event:Event):void{
      view.setSection(section.index);
      view.draw();
    }

//--------------------------------------------------------------------//
// fʂړ
    internal function sectionDown(event:Event):void{
      var sect:Pointer=view.getModel().getSection();
      if(sect.x>=0){
      	sect.x=Math.max(sect.x-1,0);
      }
      else if(sect.y>=0){
      	sect.y=Math.max(sect.y-1,0);
      }
      else if(sect.z>=0){
      	sect.z=Math.max(sect.z-1,0);
      }
      view.draw();
    }

//--------------------------------------------------------------------//
// fʂړ
    internal function sectionUp(event:Event):void{
      var sect:Pointer=view.getModel().getSection();
      if(sect.x>=0){
      	sect.x=Math.min(sect.x+1,view.getModel().getGridModel().nx-1);
      }
      else if(sect.y>=0){
      	sect.y=Math.min(sect.y+1,view.getModel().getGridModel().ny-1);
      }
      else if(sect.z>=0){
      	sect.z=Math.min(sect.z+1,view.getModel().getGridModel().nz-1);
      }
      view.draw();
    }

//--------------------------------------------------------------------//
// ^C}[s
    public function run(event:TimerEvent):void{
      if(view.getModel().getFlowParameter().isFinished()){
      	timer.stop();
      }
      else{
      	view.getModel().nextStep();
      }
      view.draw();
    }
  }
}
