package{

//--------------------------------------------------------------------//
// šW
  public class MatrixCoef{

// SW
    public var ac:Number;

// x+W
    public var axp:Number;

// x-W
    public var axm:Number;

// y+W
    public var ayp:Number;

// y-W
    public var aym:Number;

// z+W
    public var azp:Number;

// z-W
    public var azm:Number;

// 
    public var s:Number;

//--------------------------------------------------------------------//
// šW\z
    public function MatrixCoef(){
      ac=0.0;
      axp=0.0;
      axm=0.0;
      ayp=0.0;
      aym=0.0;
      azp=0.0;
      azm=0.0;
      s=0.0;
    }

//--------------------------------------------------------------------//
// Wݒ肷
// uxp - x+x
// uxm - x-x
// vyp - y+x
// vym - y-x
// wzp - z+x
// wzm - z-x
// alpha - gUW
// s - 
    public function setAdDf(uxp:Number,uxm:Number,vyp:Number,vym:Number,
      	      	      	    wzp:Number,wzm:Number,alpha:Number,s:Number,
      	      	      	    d:DiffusionCoef):void{
      axp=Math.max(0.5*Math.abs(uxp),alpha*d.d[2][1][1])-0.5*uxp;
      axm=Math.max(0.5*Math.abs(uxm),alpha*d.d[0][1][1])+0.5*uxm;
      ayp=Math.max(0.5*Math.abs(vyp),alpha*d.d[1][2][1])-0.5*vyp;
      aym=Math.max(0.5*Math.abs(vym),alpha*d.d[1][0][1])+0.5*vym;
      azp=Math.max(0.5*Math.abs(wzp),alpha*d.d[1][1][2])-0.5*wzp;
      azm=Math.max(0.5*Math.abs(wzm),alpha*d.d[1][1][0])+0.5*wzm;
      ac=axp+axm+ayp+aym+azp+azm+uxp-uxm+vyp-vym+wzp-wzm;
      this.s=s;
    }

//--------------------------------------------------------------------//
// lŒ肷
// s - Œ肷l
    public function fix(s:Number):void{
      ac=1.0;
      axp=0.0;
      axm=0.0;
      ayp=0.0;
      aym=0.0;
      azp=0.0;
      azm=0.0;
      this.s=s;
    }

//--------------------------------------------------------------------//
// Wݒ肷
// axp - x+W
// axm - x-W
// ayp - y+W
// aym - y-W
// azp - z+W
// azm - z-W
// s 
    public function set(axp:Number,axm:Number,ayp:Number,aym:Number,
      	      	      	azp:Number,azm:Number,s:Number):void{
      this.axp=axp;
      this.axm=axm;
      this.ayp=ayp;
      this.aym=aym;
      this.azp=azp;
      this.azm=azm;
      ac=axp+axm+ayp+aym+azp+azm;
      this.s=s;
    }

//--------------------------------------------------------------------//
// ԍݕݒ肷
// jdt - J/t
// p - ̃p[^l
    public function setDt(jdt:Number,p:Number):void{
      ac+=jdt;
      s+=jdt*p;
    }

//--------------------------------------------------------------------//
// SWݒ肷
    public function setCenter():void{
      var acInv:Number=1.0/ac;
      ac=1.0;
      axp*=acInv;
      axm*=acInv;
      ayp*=acInv;
      aym*=acInv;
      azp*=acInv;
      azm*=acInv;
      s*=acInv;
    }

//--------------------------------------------------------------------//
// KEX=UCf@Ŏ̃Xebv̒lԂ
// i - SxCfbNX
// j - SyCfbNX
// k - SzCfbNX
// p - p[^̃Xg
    public function next(i:int,j:int,k:int,p:Array):Number{
      return axp*p[i+1][j][k]+axm*p[i-1][j][k]+ayp*p[i][j+1][k]
      	    +aym*p[i][j-1][k]+azp*p[i][j][k+1]+azm*p[i][j][k-1]+s;
    }
  }
}
